//+------------------------------------------------------------------+
//|                                                    Fisher_EA.mq4 |
//|                                                  Variinder Singh |
//+------------------------------------------------------------------+
#property copyright "Variinder Singh"
#property link      "vicky98284@gmail.com"


#include <stderror.mqh> 
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

//========Custom settings ======

extern int  MaxOpenLong=1;
extern int  MaxOpenShort=1;
extern double Lots=0.01;
extern int MagicNumber=6876;
extern double TakeProfit =  55; 
extern double StopLoss =  25;
extern bool UseTrailingStop = false;
extern double TrailingStop = 20;
extern string EA_Comment="Vicks_EA";

static datetime lastbar;



int init()
  {
//----
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
   MoveTrailingStop();
   
    if( !IsNewBar() )
  {
    return (0);           
  }
   
   int bar=1;
   
//----
   double now1=iCustom(NULL,0,"Fisher_Yur4ik",5,1,bar);
   double now2=iCustom(NULL,0,"Fisher_Yur4ik",10,1,bar);
   double now3=iCustom(NULL,0,"Fisher_Yur4ik",15,1,bar);
   double now4=iCustom(NULL,0,"Fisher_Yur4ik",20,1,bar);
   double now5=iCustom(NULL,0,"Fisher_Yur4ik",25,1,bar);
   double now6=iCustom(NULL,0,"Fisher_Yur4ik",30,1,bar);
   double now7=iCustom(NULL,0,"Fisher_Yur4ik",35,1,bar);
   
   bool isUp = (now1 > 0) &&(now2 > 0) &&(now3 > 0) &&(now4 > 0) &&(now5 > 0) &&(now6 > 0) &&(now7 > 0);
   
   if( isUp){ 
          Print("Found buy on current candle..");
          if(CountOpenOrders(Symbol(), OP_BUY ) < MaxOpenLong ){      
              Print("Buying now at ", Bid);
              EnterLong();                    
              //CloseOpenOrder(OP_SELL);
          }
       }       
    
     bool isDown = (now1 <= 0) &&(now2 <= 0) &&(now3 <= 0) &&(now4 <= 0) &&(now5 <= 0) &&(now6 <= 0) &&(now7 <= 0); 
      if( isDown){
      Print("Found sell on current candle..");
          if(CountOpenOrders(Symbol(), OP_SELL ) < MaxOpenShort ){      
              Print("Buying now at ", Bid);
              EnterShort();                    
              //CloseOpenOrder(OP_SELL);
          }               
     }
       
//----
   return(0);
  }
//+------------------------------------------------------------------+


int CountOpenOrders( string Symbole, int TradeConst )
{
    //---- 
    int count = 0;
    if (OrdersTotal()<1)
    {
      return(count);
    }        
    for (int i = OrdersTotal() - 1; i >= 0; i--)
    {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        //if ( OrderMagicNumber() != Magic   ) continue;
        if (  OrderSymbol() != Symbole ) continue;
        
             if ( OrderType() == TradeConst  ) { count++; }
        //else if ( OrderType() == OP_SELLSTOP ) { count++; }
    }
    //----
    return(count);
}


int EnterLong(  )
{
   int Ticket = -1; int err = 0; bool OrderLoop = true; int TryCount = 0;
                     
   while( OrderLoop )
   {
      while( IsTradeContextBusy() ) { Sleep( 10 ); }
                           
     RefreshRates();                 
     double SL = Ask-StopLoss*Point;     
     double  TP =Ask+TakeProfit*Point;
     Print(" EnterLong() Ask=",Ask," StopLoss=",SL," TakeProfit=",TP);
     Ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask ,3, SL  ,TP ,EA_Comment,MagicNumber,0,Yellow);   

      int Err=GetLastError();
      Print(" Erorr entering Long ",Err);
      switch (Err) 
      {          
          // case               ERR_NO_ERROR: OrderLoop = true; 
                                       //     if( OrderSelect( Ticket, SELECT_BY_TICKET ) )
                                      //      { OrderModify( Ticket, OrderOpenPrice(), StopLong(SymBid,StopLoss, SymPoints,SymDigits), TakeLong(SymAsk,ProfitTarget,SymPoints,SymDigits), 0, CLR_NONE ); }
                                      //      break;
     
           //---- Retry Error     
           case            ERR_SERVER_BUSY:
           case          ERR_NO_CONNECTION:
           case          ERR_INVALID_PRICE:
           case             ERR_OFF_QUOTES:
           case            ERR_BROKER_BUSY:
           case     ERR_TRADE_CONTEXT_BUSY: TryCount++; break;
           case          ERR_PRICE_CHANGED:
           case                ERR_REQUOTE: continue;
     
           //---- Fatal known Error 
           case          ERR_INVALID_STOPS: OrderLoop = false; 
                         Print( "OP_BUY -- Invalid Stops"," SL = ",DoubleToStr(SL,Digits)," TP=",DoubleToStr(TP,Digits));
                         Print(" Market Stop Level = ",DoubleToStr( MarketInfo(Symbol(),MODE_STOPLEVEL),Digits));  
                          break; 
           case   ERR_INVALID_TRADE_VOLUME: OrderLoop = false; Print( "Invalid Lots"     ); break; 
           case          ERR_MARKET_CLOSED: OrderLoop = false; Print( "Market Close"     ); break; 
           case         ERR_TRADE_DISABLED: OrderLoop = false; Print( "Trades Disabled"  ); break; 
           case       ERR_NOT_ENOUGH_MONEY: OrderLoop = false; Print( "Not Enough Money" ); break; 
           case  ERR_TRADE_TOO_MANY_ORDERS: OrderLoop = false; Print( "Too Many Orders"  ); break; 
              
           //---- Fatal Unknown Error
           case              ERR_NO_RESULT:
                                   default: OrderLoop = false; Print( "Unknown Error - " + Err );Sleep( 500 ); break; 
           //----                         
       }  
       // end switch 
       if( TryCount > 10) { OrderLoop = false; }
   }
   //----               
   return(Ticket);
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Place Shrt Order                                                 |
//+------------------------------------------------------------------+
int EnterShort(  )
{
   int Ticket = -1; int err = 0; bool OrderLoop = False; int TryCount = 0;
                     
   while( !OrderLoop )
   {
      while( IsTradeContextBusy() ) { Sleep( 10 ); }
      RefreshRates();                               
      double SL = NormalizeDouble(Bid+StopLoss*Point,Digits);
      double TP = NormalizeDouble(Bid-TakeProfit*Point,Digits);
      Print(" EnterShort() Bid=",Bid," StopLoss=",SL," TakeProfit=",TP);
      
      Ticket=OrderSend(Symbol(),OP_SELL ,Lots,Bid,3, SL , TP ,EA_Comment,MagicNumber,0,Red);
     // ticket=OrderSend(Symbol(),OP_SELLSTOP,0.1,price-70*point,0,price+100*point,price-200*point,"some comment",mgnD,0,CLR_NONE);
                           
      int Err=GetLastError();
      
      switch (Err) 
      {
           //---- Success
             //    case               ERR_NO_ERROR: OrderLoop = true;
                                                 // if( OrderSelect( Ticket, SELECT_BY_TICKET ) )
                                                 // { OrderModify( Ticket, OrderOpenPrice(), StopShrt(SymAsk,StopLoss, SymPoints,SymDigits), TakeShrt(SymBid,ProfitTarget, SymPoints,SymDigits), 0, CLR_NONE ); }
                                                 // break;
     
           //---- Retry Error     
           case            ERR_SERVER_BUSY:
           case          ERR_NO_CONNECTION:
           case          ERR_INVALID_PRICE:
           case             ERR_OFF_QUOTES:
           case            ERR_BROKER_BUSY:
           case     ERR_TRADE_CONTEXT_BUSY: TryCount++; break;
           case          ERR_PRICE_CHANGED:
           case                ERR_REQUOTE: continue;
     
           //---- Fatal known Error 
           case          ERR_INVALID_STOPS: OrderLoop = true; 
                         Print( "OP_SELL -- Invalid Stops"," SL = ",DoubleToStr(SL,Digits)," TP=",DoubleToStr(TP,Digits)); 
                         Print(" Market Stop Level = ",DoubleToStr( MarketInfo(Symbol(),MODE_STOPLEVEL),Digits)); 
                         break; 
           case   ERR_INVALID_TRADE_VOLUME: OrderLoop = true; Print( "Invalid Lots"     ); break; 
           case          ERR_MARKET_CLOSED: OrderLoop = true; Print( "Market Close"     ); break; 
           case         ERR_TRADE_DISABLED: OrderLoop = true; Print( "Trades Disabled"  ); break; 
           case       ERR_NOT_ENOUGH_MONEY: OrderLoop = true; Print( "Not Enough Money" ); break; 
           case  ERR_TRADE_TOO_MANY_ORDERS: OrderLoop = true; Print( "Too Many Orders"  ); break; 
              
           //---- Fatal Unknown Error
           case              ERR_NO_RESULT:
                                   default: OrderLoop = true; Print( "Unknown Error - " + Err );Sleep( 500 ); break; 
           //----                         
       }  
       // end switch 
       if( TryCount > 10) { OrderLoop = true; }
   }
   //----               
   return(Ticket);
}


bool IsNewBar() 
{ 
datetime curbar = Time[0];

if (curbar > lastbar) 
   { 
    lastbar=curbar; 
    return (true); 
   } 
  return(false); 
}


void MoveTrailingStop()
{
  if(!UseTrailingStop)
   { return; }
  
  
  double PointValue;
  for (int i = 0; i < OrdersTotal(); i++) 
  {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      //Calculate the point value in case there are extra digits in the quotes for symbol
      if (MarketInfo(OrderSymbol(), MODE_POINT) == 0.00001) PointValue = 0.0001;
      else if (MarketInfo(OrderSymbol(), MODE_POINT) == 0.001) PointValue = 0.01;
      else PointValue = MarketInfo(OrderSymbol(), MODE_POINT);
      //Normalize trailing stop value to the point value
      double TSTP = TrailingStop * PointValue;
 
      if (OrderType() == OP_BUY)
      {
         if ((Bid - OrderOpenPrice()) > TSTP)
         {
            if (OrderStopLoss() < (Bid - TSTP))
            {
               OrderModify(OrderTicket(), OrderOpenPrice(), Bid - TSTP, OrderTakeProfit(), Red);
            }
         }
        // else if ((OrderStopLoss() != Bid - StopLoss * PointValue) && (StopLoss != 0))
        //    OrderModify(OrderTicket(), OrderOpenPrice(), Bid - StopLoss * PointValue, OrderTakeProfit(), Red);
      }
      else if (OrderType() == OP_SELL)
      {
         if ((OrderOpenPrice() - Ask) > TrailingStop * PointValue)
         {
            if ((OrderStopLoss() > (Ask + TrailingStop * PointValue)) || (OrderStopLoss() == 0))
            {
               OrderModify(OrderTicket(), OrderOpenPrice(), Ask + TSTP, OrderTakeProfit(), Red);
            }
         }
         //else if ((OrderStopLoss() != Ask + StopLoss * PointValue) && (StopLoss != 0))
         //   OrderModify(OrderTicket(), OrderOpenPrice(), Ask + StopLoss * PointValue, OrderTakeProfit(), Red);
      }
	}

}